
import threading
import os

from testing import utils

class Logger( object ):
	def __init__( self ):
		pass

	def capture_fd( self, fd, name ):
		pass

	def stop_capture( self ):
		pass


class FD_listener( object ):
	def __init__( self, fd, listener ):
		self.fd = fd
		self.listener = listener
		self.pipe = None
		self.thread = None
		try:
			self.__open()
		except:
			self.close()
			raise
	
	def nonblocking_pipe( self ):
		readable, writeable = os.pipe()
		utils.fd_blocking( readable, False )
		return (readable, writeable)
	
	def __open( self ):
		readable, writeable = self.pipe = self.create_pipe()
		self.backup_fd = os.dup( self.fd )
		os.dup2( writeable, self.fd )
		self.signaling_pipe = self.create_pipe()
		self.thread = threading.Thread( target=lambda: self.__thread() )

	def __thread( self ):
		readable, writeable = self.pipe
		stop_listener, _ = self.signaling_pipe
		while True:
			signaled,_,_ = os.select( [readable, stop_listener], [], [] )
			if readable in signaled:
				chunk = os.read( readable, 1024 )
				self.listener( chunk )
				if len(chunk) == 0:
					break
			if stop_listener in signaled:
				break

	def __del__( self ):
		self.close()
	
	def close( self ):
		if self.thread:
			_, stop_signal = self.signaling_pipe
			os.write( stop_signal, "*" )
			


class File_redirect( object ):
	def __init__( self, fd, filename ):
		self.fd = fd
		self.backup_fd = None
		self.log_fd = None
		try:
			self.backup_fd = os.dup( self.fd )
			#print >>sys.stderr, "backup_fd:", self.backup_fd
			os.close( self.fd )
			self.log_fd = os.open( filename, os.O_CREAT|os.O_WRONLY, 0600 )
			if self.log_fd != self.fd:
				os.dup2( self.log_fd, self.fd )
				#os.write( self.fd, "test\n" )
		except:
			self.close()
			raise
	
	def close( self ):
		if self.backup_fd is not None:
			os.dup2( self.backup_fd, self.fd )
			os.close( self.backup_fd )
			self.backup_fd = None
		if self.log_fd is not None and self.log_fd != self.fd:
			os.close( self.log_fd )
			self.log_fd = None
		
	def __del__( self ):
		self.close()

